This project is intended to contain high quality implementations of data structures and algorithms. Do not submit code that you just wrote for a class assignment.

If you are planning to add a new module (data structure or algorithm), you may want to open an issue to discuss your plan with the project maintainer first. This will avoid wasted effort on your part.

If you are planning to submit a pull request, please ensure that your code:
* Is written in the C programming language.
* Conforms to the project's [style guidelines](../STYLE.md).
* Does not duplicate existing code already present.
* Passes all unit test checks (existing code). Run `make check` to confirm.
* Adds unit tests (new code) with at least 95% coverage. Build with `configure –enable-coverage` to confirm.
* Is appropriately commented using full English sentences.
* Is properly documented using Doxygen comments.

Automated continuous integration checks will fail for many of the above requirements if they are not satisfied.
